VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Col. Chucks CnC Ini-File Parser (Release 1.0)"
   ClientHeight    =   5265
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   9990
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5265
   ScaleWidth      =   9990
   StartUpPosition =   3  'Windows-Standard
   Begin ComctlLib.TreeView TreeView1 
      Height          =   4215
      Left            =   210
      TabIndex        =   0
      Top             =   525
      Width           =   7035
      _ExtentX        =   12409
      _ExtentY        =   7435
      _Version        =   327682
      Indentation     =   35
      LineStyle       =   1
      Style           =   7
      Appearance      =   1
   End
   Begin VB.CheckBox Chk_Comments 
      Caption         =   "Show comments whithin a line (change needs reload of file)"
      Height          =   195
      Left            =   3675
      TabIndex        =   7
      Top             =   4935
      Width           =   4635
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Open File in Notepad and locate line"
      Height          =   330
      Left            =   210
      TabIndex        =   6
      Top             =   4830
      Width           =   3270
   End
   Begin VB.FileListBox File1 
      Height          =   2430
      Left            =   7350
      Pattern         =   "*.ini"
      TabIndex        =   5
      Top             =   2310
      Width           =   2430
   End
   Begin VB.DirListBox Dir1 
      Height          =   1665
      Left            =   7350
      TabIndex        =   4
      Top             =   525
      Width           =   2430
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   7350
      TabIndex        =   3
      Top             =   105
      Width           =   2430
   End
   Begin VB.CommandButton Cmd_Load 
      Caption         =   "Load"
      Height          =   315
      Left            =   6300
      TabIndex        =   2
      Top             =   105
      Width           =   870
   End
   Begin VB.TextBox Txt_Filename 
      Height          =   285
      Left            =   210
      TabIndex        =   1
      Text            =   "D:\test\Data\INI\DrawGroupInfo.ini"
      Top             =   105
      Width           =   5910
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' by Chuck (02/2003)
' pedder55655@gmx.net
' feel free to modify to fit your needs

Option Explicit
Dim IsLoading As Boolean

Dim Lines() As String ' our filebuffer

Public Enum t
    growing = 1
    keeping = 2
    shrinking = 3
    unknown = 4
End Enum

Public Grow As New Collection ' growing keywords
Dim GrowArray() As String


Private Sub Cmd_Load_Click()
    LoadINIFile
End Sub


Private Sub LoadINIFile()
Dim Roots As New Collection
Dim RootTypes As New Collection

Dim lineno As Long

Dim f As String
Dim line As String
Dim comment As String
Dim values As Variant
Dim typ As t

Dim i As Integer
Dim IsRoot As Boolean
Dim tmp As String

Dim LineCounter As Long: LineCounter = 0

    If IsLoading Then Exit Sub
    IsLoading = True
    f = Txt_Filename.Text
    
    ' how many lines?
    Open f For Input As #1
    While Not EOF(1)
       LineCounter = LineCounter + 1
       Line Input #1, tmp
    Wend
    Close #1
    
    ReDim Lines(LineCounter - 1)
    
    LineCounter = 0
    ' read them
    Open f For Input As #1
    While Not EOF(1)
       LineCounter = LineCounter + 1
       Line Input #1, Lines(LineCounter - 1)
    Wend
    Close #1
    
    
    TreeView1.Nodes.Clear
    
    For lineno = LBound(Lines) To UBound(Lines)
        ParseLine line, comment, Lines(lineno)
        
        If line <> "" Then
            values = Split(line, " ")
            'Debug.Print LineCounter & " : " & line
            
            
            typ = unknown
            
            'If LCase(values(0)) = "mission" Then Stop
            
            
            tmp = ""
            For i = 1 To Roots.Count
                tmp = tmp & ";" & LCase(RootTypes.Item(i)) & ";"
            Next i
            tmp = tmp & ";" & LCase(values(0)) & ";"
            For i = LBound(GrowArray) To UBound(GrowArray)
                If tmp = GrowArray(i) Then typ = growing: Exit For
            Next i
  
            'If InStr(LCase(GrowString), ";" & LCase(values(0)) & ";") > 0 Then typ = growing
            
            If LCase(values(0)) = "end" Then typ = shrinking
            
            If typ = unknown Then typ = keeping
                        
                        
            If Roots.Count > 0 Then
                'If LCase(RootTypes(RootTypes.Count)) = "particlesystem" And LCase(values(0)) = "size" Then typ = keeping ' special case
                'If LCase(RootTypes(RootTypes.Count)) = "audioevent" And LCase(values(0)) = "control" Then typ = keeping ' special case
                'If LCase(RootTypes(RootTypes.Count)) = "audioevent" And LCase(values(0)) = "sounds" Then typ = keeping ' special case
                'If LCase(RootTypes(RootTypes.Count)) = "audioevent" And LCase(values(0)) = "attack" Then typ = keeping ' special case
                'If LCase(RootTypes(RootTypes.Count)) = "commandbutton" And LCase(values(0)) = "specialpower" Then typ = keeping ' special case
                'If LCase(RootTypes(RootTypes.Count)) = "armorset" And LCase(values(0)) = "armor" Then typ = keeping ' special case
                'If LCase(RootTypes(RootTypes.Count)) = "armorset" And LCase(values(0)) = "damagefx" Then typ = keeping ' special case
                
                'If typ = growing And LCase(RootTypes(RootTypes.Count)) = LCase(values(0)) Then typ = keeping
            End If
                        
            DoEvents
            
            Dim j
            j = LineCounter & "  : " & typ & "  :  " & line
            If Roots.Count > 0 Then j = j & "   P=" & Roots.Item(Roots.Count)
            
            'Debug.Print j
            If typ <> shrinking Then
                'LastType = LCase(values(0))
                If Roots.Count = 0 Then ' real ROOT?
                    TreeView1.Nodes.Add , , "Key_" & lineno, line & comment
                Else
                    'TreeView1.Nodes.Add Roots.Item(Roots.Count), 4, "Key_" & LineCounter, line & comment
                End If
            End If
            
            If typ = growing Then
                Roots.Add "Key_" & lineno
                RootTypes.Add LCase(values(0))
            ElseIf typ = shrinking Then
                'LastType = ""
                Roots.Remove (Roots.Count)
                RootTypes.Remove (RootTypes.Count)
            End If
        End If
    
    
    
    
    Next lineno
    
    
    IsLoading = False

    

End Sub

Sub ParseLine(ByRef l As String, ByRef c As String, ByVal data As String)
Dim cut As Long
    
    l = ""
    c = ""
    cut = InStr(data, ";")
    
    If cut > 0 And Chk_Comments.Value = 1 Then
        c = "    " & Right(data, Len(data) - cut + 1)
    End If
    
    If cut > 0 Then
        l = Left(data, cut - 1)
    Else
        l = data
    End If
    
    l = Trim(l)
    
    ' delete double-spaces
    While InStr(l, "  ") > 0
        l = Replace(l, "  ", " ")
    Wend
    
End Sub

Private Sub Command1_Click()
Dim hnd
Dim t As Long
Dim line As String
    On Error Resume Next
    
    line = Replace(TreeView1.SelectedItem.Key, "Key_", "")
    line = line + 1
    hnd = Shell("notepad.exe " & Txt_Filename.Text, vbNormalFocus)
    
    AppActivate hnd
    
    SendKeys "^g"
    SendKeys line
    SendKeys "{ENTER}"
    
End Sub

Private Sub Dir1_Change()
    File1.Path = Dir1.Path
End Sub

Private Sub Drive1_Change()
On Error GoTo err:

    Dir1.Path = Drive1.Drive
    Exit Sub
err:
    Drive1.Drive = Left(Dir1.Path, 2)
End Sub


Private Sub File1_Click()
    Txt_Filename.Text = Dir1.Path & "\" & File1.FileName
End Sub

Private Sub Form_Load()
Dim x As String
    
    InitKeywords


    x = GetSetting(App.EXEName, "options", "lastfile", "")
    If x <> "" Then
        Drive1.Drive = Left(x, 2)
        Dir1.Path = Left(x, InStrRev(x, "\"))
    End If
End Sub


Sub InitKeywords()
Dim i As Integer
    
Grow.Add ";mustgrow;"
Grow.Add ";AIData;"
Grow.Add ";Animation;"
Grow.Add ";Armor;"
Grow.Add ";AudioSettings;"
Grow.Add ";Campaign;"
Grow.Add ";Campaign;;Mission;"
Grow.Add ";CommandButton;"
Grow.Add ";CommandMap;"
Grow.Add ";CommandSet;"
Grow.Add ";ControlBarResizer;"
Grow.Add ";ControlBarScheme;"
Grow.Add ";ControlBarScheme;;ImagePart;"
Grow.Add ";CrateData;"
Grow.Add ";Object;"
Grow.Add ";Object;;Draw;"
Grow.Add ";Object;;Draw;;DefaultConditionState;"
Grow.Add ";Object;;Behavior;"
Grow.Add ";Credits;"
Grow.Add ";DamageFX;"
Grow.Add ";DrawGroupInfo;"
Grow.Add ";EvaEvent;"
Grow.Add ";EvaEvent;;SideSounds;"
Grow.Add ";FXList;"
Grow.Add ";FXList;;ParticleSystem;"
Grow.Add ";FXList;;Sound;"
Grow.Add ";FXList;;LightPulse;"
Grow.Add ";FXList;;ViewShake;"
Grow.Add ";FXList;;TerrainScorch;"
Grow.Add ";FXList;;Tracer;"
Grow.Add ";FXList;;FXListAtBonePos;"
Grow.Add ";GameData;"
Grow.Add ";StaticGameLOD;"
Grow.Add ";DynamicGameLOD;"
Grow.Add ";InGameUI;"
Grow.Add ";InGameUI;;SpyDroneRadiusCursor;"
Grow.Add ";InGameUI;;AttackScatterAreaRadiusCursor;"
Grow.Add ";InGameUI;;SuperweaponScatterAreaRadiusCursor;"
Grow.Add ";InGameUI;;AttackDamageAreaRadiusCursor;"
Grow.Add ";InGameUI;;AttackContinueAreaRadiusCursor;"
Grow.Add ";InGameUI;;GuardAreaRadiusCursor;"
Grow.Add ";InGameUI;;EmergencyRepairRadiusCursor;"
Grow.Add ";InGameUI;;FriendlySpecialPowerRadiusCursor;"
Grow.Add ";InGameUI;;OffensiveSpecialPowerRadiusCursor;"
Grow.Add ";InGameUI;;ParticleCannonRadiusCursor;"
Grow.Add ";InGameUI;;A10StrikeRadiusCursor;"
Grow.Add ";InGameUI;;CarpetBombRadiusCursor;"
Grow.Add ";InGameUI;;DaisyCutterRadiusCursor;"
Grow.Add ";InGameUI;;ParadropRadiusCursor;"
Grow.Add ";InGameUI;;SpySatelliteRadiusCursor;"
Grow.Add ";InGameUI;;NuclearMissileRadiusCursor;"
Grow.Add ";InGameUI;;EMPPulseRadiusCursor;"
Grow.Add ";InGameUI;;ArtilleryRadiusCursor;"
Grow.Add ";InGameUI;;NapalmStrikeRadiusCursor;"
Grow.Add ";InGameUI;;ClusterMinesRadiusCursor;"
Grow.Add ";InGameUI;;ScudStormRadiusCursor;"
Grow.Add ";InGameUI;;AnthraxBombRadiusCursor;"
Grow.Add ";InGameUI;;AmbushRadiusCursor;"
Grow.Add ";InGameUI;;RadarRadiusCursor;"
Grow.Add ";Locomotor;"
Grow.Add ";MiscAudio;"
Grow.Add ";Mouse;"
Grow.Add ";MouseCursor;"
Grow.Add ";OnlineChatColors;"
Grow.Add ";MultiplayerSettings;"
Grow.Add ";MultiplayerColor;"
Grow.Add ";ParticleSystem;"
Grow.Add ";MusicTrack;"
Grow.Add ";ObjectCreationList;"
Grow.Add ";ObjectCreationList;;CreateDebris;"
Grow.Add ";ObjectCreationList;;CreateObject;"
Grow.Add ";ObjectCreationList;;ApplyRandomForce;"
Grow.Add ";ObjectCreationList;;DeliverPayload;"
Grow.Add ";ObjectCreationList;;DeliverPayload;;DeliveryDecal;"
Grow.Add ";ObjectCreationList;;FireWeapon;"
Grow.Add ";ObjectCreationList;;Attack;"
Grow.Add ";ObjectCreationList;;Attack;;DeliveryDecal;"
Grow.Add ";PlayerTemplate;"
Grow.Add ";Rank;"
Grow.Add ";Road;"
Grow.Add ";Bridge;"
Grow.Add ";Science;"
Grow.Add ";ShellMenuScheme;"
Grow.Add ";AudioEvent;"
Grow.Add ";SpecialPower;"
Grow.Add ";DialogEvent;"
Grow.Add ";Terrain;"
Grow.Add ";Upgrade;"
Grow.Add ";Video;"
Grow.Add ";WaterSet;"
Grow.Add ";WaterTransparency;"
Grow.Add ";Weapon;"
Grow.Add ";WebpageURL;"
Grow.Add ";WindowTransition;"
Grow.Add ";WindowTransition;;Window;"
Grow.Add ";Object;"
Grow.Add ";Object;;Draw;"
Grow.Add ";Object;;Draw;;ConditionState;"
Grow.Add ";Object;;Draw;;TransitionState;"
Grow.Add ";Object;;Draw;;DefaultConditionState;"
Grow.Add ";Object;;Draw;;AliasConditionState;"
Grow.Add ";Object;;ArmorSet;"
Grow.Add ";Object;;WeaponSet;"
Grow.Add ";Object;;Body;"
Grow.Add ";Object;;Behavior;"
Grow.Add ";Object;;Behavior;;Turret;"
Grow.Add ";Object;;Behavior;;AltTurret;"
Grow.Add ";Object;;Behavior;;GridDecalTemplate;"
Grow.Add ";Object;;Behavior;;DeliveryDecal;"
Grow.Add ";Object;;Prerequisites;"
Grow.Add ";Object;;UnitSpecificSounds;"
Grow.Add ";Object;;UnitSpecificFX;"
Grow.Add ";Object;;DeathTypes;"
Grow.Add ";ObjectReskin;"
Grow.Add ";ObjectReskin;;Draw;"
Grow.Add ";ObjectReskin;;Draw;;DefaultConditionState;"
Grow.Add ";ObjectReskin;;Draw;;ConditionState;"
Grow.Add ";ObjectReskin;;Draw;;TransitionState;"
Grow.Add ";Object;;ClientUpdate;"
    
    
    ReDim GrowArray(Grow.Count - 1)
    For i = 0 To Grow.Count - 1
        GrowArray(i) = LCase(Grow.Item(i + 1))
    Next i
    
End Sub


Private Sub Form_Unload(Cancel As Integer)
    SaveSetting App.EXEName, "options", "lastfile", Txt_Filename.Text
End Sub


Private Sub TreeView1_NodeClick(ByVal Node As ComctlLib.Node)
Dim e As String

    If Node.Children > 0 Then Exit Sub
    If Not Node.Parent Is Nothing Then Exit Sub
    
    If Node.Next Is Nothing Then
        e = "Key_" & UBound(Lines)
    Else
        e = Node.Next.Key
    End If
    
    DoProgressiveLoad Node.Key, e
End Sub

Private Sub DoProgressiveLoad(ByVal StartKey As String, ByVal StopKey As String)
Dim lineno As Long

Dim Roots As New Collection
Dim RootTypes As New Collection

Dim f As String
Dim line As String
Dim comment As String
Dim values As Variant
Dim typ As t

Dim i As Integer
Dim IsRoot As Boolean
Dim tmp As String

    
 '   Roots.Add StartKey
  '  RootTypes.Add "mustgrow"
    
    For lineno = CLng(Replace(StartKey, "Key_", "")) To CLng(Replace(StopKey, "Key_", ""))
        ParseLine line, comment, Lines(lineno)
        
        If line <> "" Then
            values = Split(line, " ")
            'Debug.Print LineCounter & " : " & line
            
            
            typ = unknown
            
            'If LCase(values(0)) = "mission" Then Stop
            
            
            tmp = ""
            For i = 1 To Roots.Count
                tmp = tmp & ";" & LCase(RootTypes.Item(i)) & ";"
            Next i
            tmp = tmp & ";" & LCase(values(0)) & ";"
            For i = LBound(GrowArray) To UBound(GrowArray)
                If tmp = GrowArray(i) Then typ = growing: Exit For
            Next i
            
  
            'If InStr(LCase(GrowString), ";" & LCase(values(0)) & ";") > 0 Then typ = growing
            
            If LCase(values(0)) = "end" Then typ = shrinking
            
            If typ = unknown Then typ = keeping
                        
            If Roots.Count > 0 Then
                'If LCase(RootTypes(RootTypes.Count)) = "particlesystem" And LCase(values(0)) = "size" Then typ = keeping ' special case
                'If LCase(RootTypes(RootTypes.Count)) = "audioevent" And LCase(values(0)) = "control" Then typ = keeping ' special case
                'If LCase(RootTypes(RootTypes.Count)) = "audioevent" And LCase(values(0)) = "sounds" Then typ = keeping ' special case
                'If LCase(RootTypes(RootTypes.Count)) = "audioevent" And LCase(values(0)) = "attack" Then typ = keeping ' special case
                'If LCase(RootTypes(RootTypes.Count)) = "commandbutton" And LCase(values(0)) = "specialpower" Then typ = keeping ' special case
                'If LCase(RootTypes(RootTypes.Count)) = "armorset" And LCase(values(0)) = "armor" Then typ = keeping ' special case
                'If LCase(RootTypes(RootTypes.Count)) = "armorset" And LCase(values(0)) = "damagefx" Then typ = keeping ' special case
                
                'If typ = growing And LCase(RootTypes(RootTypes.Count)) = LCase(values(0)) Then typ = keeping
            End If
                        
            DoEvents
            
            Dim j
            j = lineno & "  : " & typ & "  :  " & line
            If Roots.Count > 0 Then j = j & "   P=" & Roots.Item(Roots.Count)
            
            'Debug.Print j
            If typ <> shrinking Then
                'LastType = LCase(values(0))
                If Roots.Count = 0 Then ' real ROOT?
                    'TreeView1.Nodes.Add , , "Key_" & lineno, line & comment
                Else
                    TreeView1.Nodes.Add Roots.Item(Roots.Count), 4, "Key_" & lineno, line & comment
                End If
            End If
            
            If typ = growing Then
                Roots.Add "Key_" & lineno
                RootTypes.Add LCase(values(0))
            ElseIf typ = shrinking Then
                'LastType = ""
                Roots.Remove (Roots.Count)
                RootTypes.Remove (RootTypes.Count)
            End If
        End If
    
    
    
    
    Next lineno



End Sub
